#include "stdtypes.h"

#include 	<stdio.h>
#include 	<X11/X.h>
#include 	<X11/Xlib.h>
#include 	<X11/Xutil.h>
#include 	<X11/Xatom.h>

int start_X();
void end_X();
void draw_image_X();
void draw_image_patch();


Display *mydisplay;
Window mywindow;
int myscreen;
GC mygc;
XEvent myevent;
XImage *image;
XStandardColormap grayscale;
XSetWindowAttributes myattr;

void draw_image_X(p, x, y)
unsigned char *p;
int x, y;
{
	image->data = (char *)p;
	XPutImage( mydisplay, mywindow, mygc, image, 0, 0, x, y, 352,288);
}


int start_X(width, height)
int width, height;
{
	XSizeHints myhint;
	unsigned long myforeground, mybackground;
	unsigned long cmapindex[256];
	XColor color;
	Colormap colormap;
	unsigned depth;
	Visual *vis;
	XVisualInfo visualinfo;
	int i;

	if ( ( mydisplay = XOpenDisplay("") ) == NULL )
		return 1;
	myscreen = DefaultScreen( mydisplay );
	if ( ( depth = DefaultDepth( mydisplay, myscreen ) ) < 8 )
		return 1;
	vis = DefaultVisual( mydisplay, myscreen );
	if ( vis->class == StaticColor || vis->class == StaticGray )
		return 1;
	mybackground = WhitePixel( mydisplay, myscreen );
	myforeground = BlackPixel( mydisplay, myscreen );
	myhint.x = 200; myhint.y = 300;
	myhint.width = width*2; myhint.height = height;
	myhint.flags = PPosition | PSize;
	mywindow = XCreateSimpleWindow( mydisplay, DefaultRootWindow
		( mydisplay ), myhint.x, myhint.y, myhint.width, myhint.height,
		5, myforeground, mybackground );

	XSetStandardProperties( mydisplay, mywindow, "JPEG Simulation (Left Window: Original Image.   Right Window: Decoded Image)", "JPEG", None, NULL, 0, &myhint );

	/* Create an Image structure */
	image = XCreateImage( mydisplay, visualinfo.visual,
		depth, ZPixmap, 0, 0, width*2, height, 8, width );

	/* Set GC */
	mygc = XCreateGC( mydisplay, mywindow, 0, 0 );
	XSetBackground( mydisplay, mygc, mybackground );
	XSetForeground( mydisplay, mygc, myforeground );

	/* Set Input Attributes */
	XSelectInput( mydisplay, mywindow, ButtonPressMask | KeyPressMask |
		ExposureMask );

	/* Map the window to the screen */
	XMapRaised( mydisplay, mywindow );

	/* For Window positioning */
	XNextEvent( mydisplay, &myevent );

	/* Set the Lookup table */
	colormap = XCreateColormap( mydisplay, mywindow, vis,
			AllocNone );
	if ( ! XAllocColorCells( mydisplay, colormap, False, NULL, 0, 
		cmapindex, 256 ) )
		return 1;
	color.flags = DoRed | DoGreen | DoBlue;
	for ( i=0; i<256; i++ )
	{
		color.pixel = cmapindex[i];
		color.red = color.blue = color.green = 65535 / 255 * i;
		XStoreColor( mydisplay, colormap, &color );
	}
	XSetWindowColormap( mydisplay, mywindow, colormap );
/*
	XInstallColormap( mydisplay, colormap );	
*/

	/* Map the window to the screen */
	return 0;
}

void end_X()
{
	XGetStandardColormap( mydisplay, RootWindow( mydisplay, myscreen ),
		&grayscale, XA_RGB_DEFAULT_MAP );
	myattr.colormap = grayscale.colormap;
	XChangeWindowAttributes( mydisplay, mywindow, CWColormap, &myattr );
	XCloseDisplay( mydisplay );
}

